<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__sysint" kind="group">
    <compoundname>group_sysint</compoundname>
    <title>SysInt       (System Interrupt)</title>
    <innergroup refid="group__group__sysint__macros">Macros</innergroup>
    <innergroup refid="group__group__sysint__globals">Global variables</innergroup>
    <innergroup refid="group__group__sysint__functions">Functions</innergroup>
    <innergroup refid="group__group__sysint__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__sysint__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>The SysInt driver provides an API to configure the device peripheral interrupts. </para>    </briefdescription>
    <detaileddescription>
<para>It provides a lightweight interface to complement the <ulink url="https://www.keil.com/pack/doc/CMSIS/Core/html/group__NVIC__gr.html">CMSIS core NVIC API</ulink>. The provided functions are applicable for all cores in a device and they can be used to configure and connect device peripheral interrupts to one or more cores.</para><para>The functions and other declarations used in this driver are in cy_sysint.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para>
<para><heading level="1">Vector Table</heading></para>
<para>The vector table defines the entry addresses of the processor exceptions and the device specific interrupts. It is located at the start address of the flash and is copied by the startup code to RAM. The symbol code __Vectors is the address of the vector table in the startup code and the register SCB-&gt;VTOR holds the start address of the vector table. See <ref kindref="member" refid="group__group__system__config_1group_system_config_device_vector_table">Vectors Table Copy from Flash to RAM</ref> section for the implementation details.</para><para>The default interrupt handler functions are defined as weak functions to a dummy handler in the startup file. The naming convention is &lt;interrupt_name&gt;_IRQHandler. Defining these in the user application allows the linker to place them in the vector table in flash. For example: <programlisting><codeline><highlight class="normal">void<sp />ioss_interrupts_gpio_0_IRQHandler(void)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />...</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> And can be used like this: <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />Vector<sp />table<sp />is<sp />not<sp />relocated<sp />anywhere<sp />from<sp />_Vectors[]<sp />in<sp />flash<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />(CY_CPU_CORTEX_M0P)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Prototype<sp />of<sp />ISR<sp />function<sp />for<sp />NvicMux7,<sp />defined<sp />as<sp />a<sp />weak<sp />function<sp />in<sp />startup_psoc0x_cm0plus.s<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />NvicMux7_IRQHandler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp />intrCfg<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.intrSrc<sp />=*/</highlight><highlight class="normal"><sp />NvicMux7_IRQn,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />CM0+<sp />interrupt<sp />is<sp />NVIC<sp />#7<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.cm0pSrc<sp />=*/</highlight><highlight class="normal"><sp />ioss_interrupts_gpio_0_IRQn,<sp /></highlight><highlight class="comment">/*<sp />Source<sp />of<sp />NVIC<sp />#7<sp />is<sp />GPIO<sp />port<sp />0<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.intrPriority<sp />=*/</highlight><highlight class="normal"><sp />2UL<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Interrupt<sp />priority<sp />is<sp />2<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Prototype<sp />of<sp />ISR<sp />function<sp />for<sp />gpio<sp />interrupt<sp />0,<sp />defined<sp />as<sp />a<sp />weak<sp />function<sp />in<sp />startup_psoc0x_cm4.s<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />ioss_interrupts_gpio_0_IRQHandler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp />intrCfg<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.intrSrc<sp />=*/</highlight><highlight class="normal"><sp />ioss_interrupts_gpio_0_IRQn,<sp /></highlight><highlight class="comment">/*<sp />Interrupt<sp />source<sp />is<sp />GPIO<sp />port<sp />0<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.intrPriority<sp />=*/</highlight><highlight class="normal"><sp />4UL<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Interrupt<sp />priority<sp />is<sp />4<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />interrupt<sp />with<sp />vector<sp />at<sp />Interrupt_Handler_Port0()<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init</ref>(&amp;intrCfg,<sp />(<ref kindref="member" refid="group__group__syslib__macros_1ga71c09beda7671d1f69c8f06a546e2ae6">cy_israddress</ref>)NULL);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_EnableIRQ(intrCfg.<ref kindref="member" refid="structcy__stc__sysint__t_1a6da08d81da65a7f93d3e4c46a4b8d950">intrSrc</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting>Using this method avoids the need for a RAM vector table. However in this scenario, interrupt handler re-location at run-time is not possible, unless the vector table is relocated to RAM.</para>

<para><heading level="1">Driver Usage</heading></para>

<para><bold>Initialization</bold></para>
<para>Interrupt numbers are defined in a device-specific header file, such as cy8c68237bz_ble.h, and are consistent with interrupt handlers defined in the vector table.</para><para>To configure an interrupt, call <ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init()</ref>. Populate the configuration structure (<ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref>) and pass it as a parameter along with the ISR address. This initializes the interrupt and instructs the CPU to jump to the specified ISR vector upon a valid trigger. For CM0+ core, the configuration structure (<ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref>) must specify the device interrupt source (cm0pSrc) that feeds into the CM0+ NVIC mux (intrSrc).</para><para>For CM4 core, system interrupt source 'n' is connected to the corresponding IRQn. Deep-sleep capable interrupts are allocated to Deep Sleep capable IRQn channels.</para><para>For CM0+ core, deep Sleep wakeup-capability is determined by the CPUSS_CM0_DPSLP_IRQ_NR parameter, where the first N number of muxes (NvicMux0 ... NvicMuxN-1) have the capability to trigger Deep Sleep interrupts. A Deep Sleep capable interrupt source must be connected to one of these muxes to be able to trigger in Deep Sleep. Refer to the IRQn_Type definition in the device header.</para><para><orderedlist>
<listitem><para>For CPUSS_ver1 the CM0+ core supports up to 32 interrupt channels (IRQn 0-31). To allow all device interrupts to be routable to the NVIC of this core, there is a 240:1 multiplexer at each of the 32 NVIC channels.</para></listitem><listitem><para>For CPUSS_ver2 the CM0+ core supports up to 8 hardware interrupt channels (IRQn 0-7) and software-only interrupt channels (IRQn 8-15). The device has up to 1023 interrupts that can be connected to any of the hardware interrupt channels. In this structure, multiple interrupt sources can be connected simultaneously to one NVIC channel. The application must then query the interrupt source on the channel and service the active interrupt(s). The priority of these interrupts is determined by the interrupt number as defined in the cy_en_intr_t enum, where the lower number denotes higher priority over the higher number.</para></listitem></orderedlist>
</para>

<para><bold>Enable</bold></para>
<para>After initializing an interrupt, use the CMSIS Core <ulink url="https://www.keil.com/pack/doc/CMSIS/Core/html/group__NVIC__gr.html#ga530ad9fda2ed1c8b70e439ecfe80591f">NVIC_EnableIRQ()</ulink> function to enable it. Given an initialization structure named config, the function should be called as follows: <programlisting><codeline><highlight class="normal">NVIC_EnableIRQ(config.intrSrc)</highlight></codeline>
</programlisting></para>

<para><bold>Writing an interrupt service routine</bold></para>
<para>Servicing interrupts in the Peripheral Drivers should follow a prescribed recipe to ensure all interrupts are serviced and duplicate interrupts are not received. Any peripheral-specific register that must be written to clear the source of the interrupt should be written as soon as possible in the interrupt service routine. However, note that due to buffering on the output bus to the peripherals, the write clearing of the interrupt may be delayed. After performing the normal interrupt service that should respond to the interrupting condition, the interrupt register that was initially written to clear the register should be read before returning from the interrupt service routine. This read ensures that the initial write has been flushed out to the hardware. Note, no additional processing should be performed based on the result of this read, as this read is intended only to ensure the write operation is flushed.</para><para>This final read may indicate a pending interrupt. What this means is that in the interval between when the write actually happened at the peripheral and when the read actually happened at the peripheral, an interrupting condition occurred. This is ok and a return from the interrupt is still the correct action. As soon as conditions warrant, meaning interrupts are enabled and there are no higher priority interrupts pending, the interrupt will be triggered again to service the additional condition.</para>


<para><heading level="1">Configuration Considerations</heading></para>
<para>Certain CM0+ <ulink url="https://www.keil.com/pack/doc/CMSIS/Core/html/group__NVIC__gr.html#ga7e1129cd8a196f4284d41db3e82ad5c8">NVIC IRQn</ulink> channels are reserved for system use: <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;NVIC channel (&lt;a href="group__group__sysint__enums.html#group__group__sysint__enums_1ga7e1129cd8a196f4284d41db3e82ad5c8"&gt;IRQn_Type&lt;/a&gt;)&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Interrupt source (&lt;a href="group__group__sysint__enums.html#group__group__sysint__enums_1ga8010dee187715cab833c8564fccedc20"&gt;cy_en_intr_t&lt;/a&gt;)&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Purpose &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;#0 (NvicMux0_IRQn)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;IPC Interrupt #0 (cpuss_interrupts_ipc_0_IRQn)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;System Calls to ROM &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;#1 (NvicMux1_IRQn)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;IPC Interrupt #3 (cpuss_interrupts_ipc_3_IRQn)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;System IPC pipe in the default startup &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;For CPUSS_ver2, each NVIC channel can be shared between multiple interrupt sources. However it is not recommended to share the application NVIC channel with the reserved channels.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><heading level="1">More Information</heading></para>
<para>Refer to the technical reference manual (TRM) and the device datasheet.</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;8.12 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Array declared with unknown size. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;__Vectors and __ramVectors arrays can have the different size depend on the selected device.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.30.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The Cy_SysInt_SetNmiSource is updated with Protection Context check for CM0+. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.20.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The Vector Table section is extended with a code snippet. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;1.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added CPUSS_ver2 support to the following API functions:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__sysint__functions.html#group__group__sysint__functions_1ga59e3d1e09d83aa163865bcf5f363d7c3"&gt;Cy_SysInt_SetInterruptSource&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__sysint__functions.html#group__group__sysint__functions_1ga82208c7a076f5f0f750986e84c3d5df0"&gt;Cy_SysInt_SetNmiSource&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__sysint__functions.html#group__group__sysint__functions_1gabb19f0ef37e4b807fc33bd446a185b83"&gt;Cy_SysInt_GetNmiSource&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;p&gt;Added new API functions:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__sysint__functions.html#group__group__sysint__functions_1ga7be24fe4952cebbba78e612463981287"&gt;Cy_SysInt_DisconnectInterruptSource&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__sysint__functions.html#group__group__sysint__functions_1ga7caa3ebc40ed414983d1330e01dbb932"&gt;Cy_SysInt_GetNvicConnection&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__sysint__functions.html#group__group__sysint__functions_1ga9e42b44b1946290e12f25ff5042f1fc0"&gt;Cy_SysInt_GetInterruptActive&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;p&gt;Deprecated following functions:&lt;ul&gt;&lt;li&gt;&lt;p&gt;Cy_SysInt_SetIntSource&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_SysInt_GetIntSource&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_SysInt_SetIntSourceNMI&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_SysInt_GetIntSourceNMI  &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;New devices support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Cy_SysInt_GetState() function is redefined to call NVIC_GetEnableIRQ() &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>